/*******************************************************
 Quiz: to enable testing of simple concepts in C++
 (c) 1997 Roger Hartley
*******************************************************/


#include <iostream.h>
#include <strstream.h>
#include <string>

#define QUIZ(title, type, name) Quiz(#title, &name, #type, #name)

void QuizMain();

// Quiz takes:
//    title: a string to be displayed as a header
//    pv: a pointer to the variable whose value is to
//        be tested ffor
//    t: a string for the type anme of the variable pv
//       points to
//    n: a string for the variable name
void Quiz(const string& title, void* pv, const string& t, const string& n) {
	cout << title << endl << endl;
	ostrstream res;
	if (t == "int")
		res << *(int*)pv << '\0';
	else if (t == "float") {
	        res.setf(ios::showpoint);
	        res.precision(2);
		res << *(float*)pv << '\0';
	    }
	else if (t == "char")
		res << *(char*)pv << '\0';
	else if (t == "double") {
	        res.setf(ios::showpoint);
	        res.precision(2);
		res << *(double*)pv << '\0';
	    }
	else if (t == "short")
		res << *(short*)pv << '\0';
	else if (t == "long")
		res << *(long*)pv << '\0';
	else if (t == "char*")
		res << *(char**)pv << '\0';

	string ans;
	cout << "What is the value of " << n << "? ";
	cin >> ans;
	while (!(ans == res.str())) {
		cout << "No! Try again or press ctrl-c to exit" << endl;
		cout << "What is the value of " << n << "? ";
		cin >> ans;
	}

	cout << "Congratulations! That's right." << endl;
}

int main() {
	QuizMain();
}
